/*
 *  TPngPictControl.h
 *  AUStk
 *
 *  Created by Airy Andr on Sun Oct 20 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef TPngPictControl_H_
#define TPngPictControl_H_

#include "TViewNoCompositingCompatible.h"

#define kTPngPictControlClassID	CFSTR( "com.airy.ctrl.png" )

class TPngPictControl
: public TViewNoCompositingCompatible
{
public:
    static OSStatus Create(
			   HIViewRef*					outControl,
			   const HIRect*				inBounds = NULL,
			   WindowRef					inWindow = NULL,
			   CFStringRef 				classID = kTPngPictControlClassID);
    
    static HIObjectClassRef mClassRef;
    static void RegisterClass(CFStringRef str = kTPngPictControlClassID);
    static void RegisterClassForBundleID(CFStringRef bid);
    static void SetClassBundle(CFBundleRef sBundle);

    // Accessors

protected:
	// Contstructor/Destructor
	TPngPictControl(HIViewRef inControl);
    virtual ~TPngPictControl();

    virtual ControlKind		GetKind();

    virtual OSStatus		Initialize( TCarbonEvent& inEvent );
    virtual void		CompatibleDraw(RgnHandle	inLimitRgn, CGContextRef inContext,bool  inCompositing );
    virtual OSStatus		TitleChanged();
    virtual OSStatus		GetRegion(ControlPartCode inPart, RgnHandle outRgn );
    virtual UInt32			GetBehaviors();

private:
    CFBundleRef mBundleRef;
    CGImageRef mImage;
    
    static CFBundleRef      sStaticBundle;
    static OSStatus		Construct(ControlRef inControl, TView**	outView);


};

#endif // 