/*
 *  TViewNoCompositingCompatible.cpp
 *  NeuSynth
 *
 *  Created by Airy Andr on Wed Nov 06 2002.
 *  Copyright (c) 2002 __MyCompanyName__. All rights reserved.
 *
 */

#include "TViewNoCompositingCompatible.h"
#include "TRect.h"

//-----------------------------------------------------------------------------------
//	Draw
//-----------------------------------------------------------------------------------
//	The fun part of the control
//
void TViewNoCompositingCompatible::Draw(
			   RgnHandle				inLimitRgn,
			   CGContextRef			inContext )
{
    CGContextRef			context = inContext;
    GrafPtr graphPtr;
    bool compositing = (inContext != 0);

    if (!compositing) { // When called in a not compositing window
        graphPtr=GetWindowPort(GetOwner());
	SetPortWindowPort(GetOwner());
	TRect bounds = Bounds();
	Rect r = bounds;

	EraseRect ( &r );

	QDBeginCGContext(graphPtr, &context);
	Rect rect;
	GetPortBounds(graphPtr, &rect);
	CGContextTranslateCTM(context, 0, float(rect.bottom-rect.top));
	CGContextScaleCTM(context, 1, -1);
	CGContextClipToRect(context, bounds);
    }
    // Call the real draw routine
    CompatibleDraw(inLimitRgn, context, compositing);
    
    if (!compositing) {
	CGContextSynchronize ( context );
	QDEndCGContext (graphPtr, &context );
    }
}
